/*
 * Copyright (c) 2018 Cybozu
 * Licensed under the MIT License
 */
jQuery.noConflict();
(function($) {
    'use strict';
    const util = {
        APP: {
            ID: 1 //kintoneのアプリIDに書き換えてください
        },
        FIELDS: {
            レコード番号: {
                CODE: '$id'
            },
            会社名: {
                CODE: '会社名'
            },
            部署名: {
                CODE: '部署名'
            },
            先方担当者: {
                CODE: '先方担当者'
            },
            見込み時期: {
                CODE: '見込み時期'
            },
            案件担当者名: {
                CODE: '案件担当者名'
            },
            製品名: {
                CODE: '製品名'
            },
            単価: {
                CODE: '単価'
            },
            ユーザー数: {
                CODE: 'ユーザー数'
            }
        },
        FUNCTION: {
            getRecords: function(APP_ID, query) {
                return new garoon.Promise((resolve, reject) => {
                    const xmlhttp = new XMLHttpRequest();
                    xmlhttp.open('GET', '/k/v1/records.json?app=' + APP_ID + '&query=' + query);
                    xmlhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');

                    xmlhttp.onload = function() {
                        if (xmlhttp.status === 200) {
                            resolve(JSON.parse(xmlhttp.response));
                        } else {
                            reject(JSON.parse(xmlhttp.response));
                        }
                    };
                    xmlhttp.send();
                });
            }
        }
    };

    const query = util.FIELDS.案件担当者名.CODE +
  ' in (LOGINUSER()) and ' + util.FIELDS.見込み時期.CODE +
  ' >= "2015-08-31" order by ' + util.FIELDS.見込み時期.CODE + ' desc limit 100';
    util.FUNCTION.getRecords(util.APP.ID, query).then((resp) => {
        const records = resp.records;
        const $thIcon = $('<th>').addClass('thead__th record__icon');
        const $ths = Object.keys(util.FIELDS).map((field) => {
            return $('<th>').addClass('thead__th ' + field).text(field);
        });

        const $trs = records.map((record, i) => {
            const $tr = $('<tr>');
            if (i % 2 === 0) {
                $tr.addClass('tbody__row--odd');
            }

            const $icon = $('<td>').addClass('record__icon').append(
                $('<a>').attr('href', location.origin + '/k/' + util.APP.ID + '/show#record=' + record.$id.value).append(
                    $('<i>').addClass('fas fa-file icon__color')
                )
            );

            const $tdId = $('<td>').addClass('tbody__td').text(record[util.FIELDS.レコード番号.CODE].value);
            const $tdCompany = $('<td>').addClass('tbody__td').text(record[util.FIELDS.会社名.CODE].value);
            const $tdDept = $('<td>').addClass('tbody__td').text(record[util.FIELDS.部署名.CODE].value);
            const $tdCustomer = $('<td>').addClass('tbody__td').text(record[util.FIELDS.先方担当者.CODE].value);
            const $tdExpectedTime = $('<td>').addClass('tbody__td').text(record[util.FIELDS.見込み時期.CODE].value);
            const $tdAssigned = $('<td>').addClass('tbody__td').text(record[util.FIELDS.案件担当者名.CODE].value.map((user) => {
                return user.name;
            }).join(', '));
            const $tdProduct = $('<td>').addClass('tbody__td').text(record[util.FIELDS.製品名.CODE].value);
            const $tdPrice = $('<td>').addClass('tbody__td').text(record[util.FIELDS.単価.CODE].value);
            const $tdUserNum = $('<td>').addClass('tbody__td').text(record[util.FIELDS.ユーザー数.CODE].value);

            return $tr.append(
                $icon, $tdId, $tdCompany, $tdDept, $tdCustomer, $tdExpectedTime, $tdAssigned, $tdProduct, $tdPrice, $tdUserNum
            );
        });

        $('.thead__content').append($thIcon, $ths);
        $('.tbody__content').append($trs);
    });
}(jQuery));

